//PIN V1.18, 13.02.2006
//von Johannes Hogrefe
//(johannes_hogrefe@web.de)

#define USE_TI89  //Kompilieren fr TI89
#define USE_TI92PLUS  //Kompilieren fr TI92(PLUS)
#define USE_V200  //Kompilieren fr TI Voyage 200

#define MIN_AMS 205  //Programm bentigt AMS-Version 2.05 oder hher

#include <tigcclib.h>

void _main(void)
{
  LCD_BUFFER *lcd = HeapAllocPtr(sizeof(LCD_BUFFER));  //Reservieren des Speichers fr Bildschirmvariable
  LCD_save(lcd);  //Speichern des Bildschirms

  int tmp = 0;
  int key = 0;
	char pin_1[21];
	char pin_2[21];
	int i;
	
  clrscr();	
  FontSetSys(F_6x8);
	
	FILE *fp;
	fp = fopen ("main\\pindata", "r");
	if(fp != NULL)  //Testen ob Variable 'pindata.PIN' vorhanden
	{
		for(i = 0; i < 21; i++)
		{
			pin_1[i] = fgetc(fp);
		}
		fclose(fp);
	}
	else
	{	
	  //Variable 'pindata.PIN' wird erstelltt
		fp = fopen ("main\\pindata", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(i = 0; i < 21; i++)
		{
			fputc(pin_1[i], fp); 
		}
		fputc (0, fp);
		fputs ("PIN", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
		
		//Eingabe des neuen PINs
		printf_xy(0,0,"Neuer PIN:");
		for(tmp = 0; tmp < 21; tmp++)
		  pin_1[tmp] = 0; 
		tmp = 0;
		do
		{
			key = ngetchx();
			if(key == 257 && tmp)
			{
				tmp--;
				printf_xy(tmp*6,10," ");
				pin_1[tmp] = 0;
			}
			if(key < 256 && key != 13 && key != 0 && tmp < 20)
			{
				printf_xy(tmp*6,10,"*");
				pin_1[tmp] = key;
				tmp++;
			}
		}
		while(key != 13);
		  printf_xy(tmp*6+62,90," ");
		
		//Speichern des neuen PINs in Variable 'pindata.PIN'
		fp = fopen ("main\\pindata", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(i = 0; i < 21; i++)
		{
			fputc(pin_1[i], fp); 
		}
		fputc (0, fp);
		fputs ("PIN", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
	}
	
	//Eingeben des PINs
	Main:
  clrscr();
	off();
	FontSetSys(F_6x8);
	printf_xy(0,0,"PIN eingabe:");
	for(tmp = 0; tmp < 21; tmp++)
	  pin_2[tmp] = 0; 
	tmp = 0;
	do
	{
		key = ngetchx();
		if(key == 257 && tmp)
		{
			tmp--;
		  printf_xy(tmp*6,10," ");
			pin_2[tmp] = 0;
		}
		if(key < 256 && key != 13 && key != 0 && tmp < 20)
		{
			printf_xy(tmp*6,10,"*");
			pin_2[tmp] = key;
			tmp++;
		}
	}
	while(key != 13);
		 printf_xy(tmp*6+62,90," ");
	
	//Prfen ob PINs identisch	
	for (i = 0; i < 21; i++)
	{
		if (pin_1[i] != pin_2[i])
		{ 
		  clrscr();
		  FontSetSys(F_8x10);
			printf_xy(0,0,"Falscher PIN!");
			ngetchx();
			goto Main;
		}
	}
	LCD_restore(lcd);  //Wiederherstellen des Bildschirms
	HeapFreePtr(lcd);  //Freigeben des Speichers fr Bildschirmvariable
  ST_helpMsg("PIN v1.18 von Johannes Hogrefe");
}
